class Board {
/*Feleptijuk a cellakbol allo tablat*/
  val board = List(
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell(),
      new Cell()
  );
  /*A lehetseges nyero kimbinaciok*/
  val winningPaths = List(
    List(0,1,2),
    List(3,4,5),
    List(6,7,8),
    List(0,3,6),
    List(1,4,7),
    List(2,5,8),
    List(0,4,8),
    List(2,4,6)
  );
  /*Megvizsgalja, hogy a parameterul kapott path nyero path-e*/
   def pathContainsWinner( path: List[Int] ) = {
        val cell1 = this.board( path( 0 ) );
        val cell2 = this.board( path( 1 ) );
        val cell3 = this.board( path( 2 ) );
 
        cell1.isOccupied() &&
        (cell1 == cell2) &&
        (cell1 == cell3);
    };
  
   /*Megvizsgalja, hogy az aktualis allapotban nyerte-e valaki*/
  def hasWinner():Boolean = {
      this.winningPaths.foreach( path =>
            if (this.pathContainsWinner( path )){
                return( true );
            }
        );
        return( false );
  };
  
 /*Visszaadja a nyertes jatekost, abban az esetben, ha letezik ilyen*/
  def getWinner():String = {
        if (!this.hasWinner){
            throw new IllegalStateException( "The board does not have a winner." );
        }
        this.winningPaths.foreach( path =>
            if (this.pathContainsWinner( path )){
                return(this.board( path( 0 ) ).getOccupant());
            }
        );
        return("");
  };
  
  /*Megvizsgalja, hogy van-e a tablan ures cella*/
   def hasFreeCells():Boolean = {
        this.board.foreach( cell =>
            if (!cell.isOccupied()){
                return( true );
            }
        );
        return( false );
    };
   
    /*Megvizsgalja, hogy lehetseges-e kovetkezo lepes(van-e ures cella es meg nem nyert senki)*/
    def hasNextMove() = {
        (this.hasFreeCells() && !this.hasWinner());
    };
    
    /*Megnezi, hogy dontetlen allapotba kerult-e a tabla*/
    def isTieBoard() = {
        (!this.hasFreeCells() && !this.hasWinner());
    };
     
    /*Adott indexu cellara beallitja az adott jatekost*/
    def setOccupant(index: Int, occupant: String) = {
        this.board(index).setOccupant(occupant);
    };
    
    override def toString():String = {
        return(
            this.board(0) + " | " +
            this.board(1) + " | " +
            this.board(2) + "\n" +
            "---------\n" +
            this.board(3) + " | " +
            this.board(4) + " | " +
            this.board(5) + "\n" +
            "---------\n" +
            this.board(6) + " | " +
            this.board(7) + " | " +
            this.board(8) + "\n"
        );
    };
  
}