class Cell {

  var occupant = "";
  
  val validOccupants = List("X", "O");
  
  /*Osszehasonlitja, hogy egyezik-e a cella tartalma a parameterul kapott cellaeval*/
  def ==(target: Cell):Boolean = {
    return (this.getOccupant() == target.getOccupant());
  }
  
  def getOccupant():String = this.occupant;
  
  /*Visszaadja, hogy szabad-e a cella*/
  def isOccupied() = {
    (this.getOccupant != "");
  }
  
  /*Egy kapott stringrol megnezi-e, hogy ervenyes jatekos-e*/
  def isValidOccupant(occupant: String) = {
    this.validOccupants.contains(occupant);
  }
  
  /*Beallitja a cella tartalmat a parameterul kapott jatekosra*/
  def setOccupant(newOccupant: String):Unit = {
    if(this.isOccupied()){
    	throw new IllegalStateException( "A cella mar foglalt a kovetkezo jatekos altal: " + this.occupant );
    }
    if(!this.isValidOccupant(newOccupant)){
    	throw new IllegalArgumentException( "Helytelen bemenet. Lehetosegek: " + this.validOccupants );
    }
    this.occupant = newOccupant;
  }
  
  override def toString():String = {
    if(this.isOccupied()){
      return(this.getOccupant);
    } else {
      return(".");
    }
  }
  
}